Name: yudit
Version: 2.5.4
Release: 1
Group: Applications/Editors
License: GPL
Source: %{name}-%{version}.tar.gz
Summary: Unicode Text Editor
BuildRoot: /var/tmp/%{name}-%{version}-root
Prefix: /usr

%description
Yudit is a unicode text editor for  the X Window
System.  She  can  do True  Type font rendering, 
printing,   transliterated  keyboard  input  and 
handwriting recognition with no dependencies  on
on external  engines. Her  conversion  utilities
can  convert  text  between  various  encodings.
Keyboard  input   maps  can  also  act like text 
converters. There is no need for a pre-installed
multi-lingual environment. Menus are  translated
into many languages.

GNU (C) Gaspar Sinai <gsinai@yudit.org> 

%prep
%setup
%configure

%build
make

%install
rm -fr $RPM_BUILD_ROOT
mkdir $RPM_BUILD_ROOT
mkdir $RPM_BUILD_ROOT%{prefix}
make DESTDIR=$RPM_BUILD_ROOT install
mkdir -p $RPM_BUILD_ROOT/etc/X11/applnk/Applications $RPM_BUILD_ROOT/usr/share/pixmaps
install -m 644 gnome-yudit.png $RPM_BUILD_ROOT/usr/share/pixmaps/yudit.png
cat >$RPM_BUILD_ROOT/etc/X11/applnk/Applications/yudit.desktop <<EOF
[Desktop Entry]
Name=Yudit (Unicode editor)
Type=Application
Description=The Yudit Unicode editor
Exec=yudit
Icon=yudit.png
EOF


%clean

%files
%defattr(-,root,root)
%{prefix}/bin/uniconv
%{prefix}/bin/uniprint
%{prefix}/bin/yudit
%{prefix}/bin/mytool
%{_mandir}/man1/*

%dir %{_datadir}/yudit
%{_datadir}/yudit/data
%{_datadir}/yudit/fonts
%{_datadir}/yudit/src 
%{_datadir}/yudit/doc 
%dir %{_datadir}/yudit/locale
%{_datadir}/yudit/locale/ar
%{_datadir}/yudit/locale/az
%{_datadir}/yudit/locale/cz
%{_datadir}/yudit/locale/bg
%{_datadir}/yudit/locale/de
%{_datadir}/yudit/locale/en
%{_datadir}/yudit/locale/es
%{_datadir}/yudit/locale/fi
%{_datadir}/yudit/locale/fr
%{_datadir}/yudit/locale/hi
%{_datadir}/yudit/locale/hu
%{_datadir}/yudit/locale/ja
%{_datadir}/yudit/locale/sl
%{_datadir}/yudit/locale/sr
%{_datadir}/yudit/locale/ta
%{_datadir}/yudit/locale/uk
%{_datadir}/yudit/locale/yi

%dir %{_datadir}/yudit/config
%config %{_datadir}/yudit/config/*
%config /etc/X11/applnk/Applications/yudit.desktop
%config /usr/share/pixmaps/yudit.png

%doc CHANGELOG.TXT COPYING.TXT FAQ.TXT README.TXT TODO.TXT doc/*.utf8 doc/notinstalled doc/problems doc/HOWTO-*.txt

%changelog
* Sat Feb 28 2002 Gaspar Sinai <gsinai@yudit.org>
- Malayalam support (Miikka)
- Kannada support (Miikka)
- Telugu support (Miikka)
- koi8-c support (Miikka)
- koi8-u support (Gaspar)
- ncr converter (Miikka)
- rovas converter (Gaspar)
- iso-8859-15 converter (Gaspar)
- iso-8859-16 converter (Gaspar)
- Mirrored characters (Miikka-Gaspar)
- Old Hungarian support with ligatures in Private Use Area (Gaspar)
- Ukrainian kmap and translations (Solotskyy)
* Wed Jan 26 2002 Gaspar Sinai <gsinai@yudit.org>
- Pango X11 Ligature support
- Devanagari support (Miikka)
- Bengali support (Miikka)
- Gujarati support (Miikka)
- Gurmukhi support (Miikka)
- Oriya support (Miikka)
- Hindi menu (Sanjay)
* Wed Jan 02 2002 Gaspar Sinai <gsinai@yudit.org>
- Tamil support (Vasee)
- Added Hangul Jamos (Miikka-Markus)
- OpenType Ligature substitution support
- Testing other Indic scripts.
- Fixed bumap.
* Tue Nov 27 2001 Gaspar Sinai <gsinai@yudit.org>
- Prepearing for 2.5 with shaping (Arabic) support.
- Changed (removed -e, added auto-tmpfile): yudit.default.preview.command=gv
* Fri Nov 09 2001 Gaspar Sinai <gsinai@yudit.org>
- Fixed shift-jis converter
- Optimized speed
- Fixed layout manager bugs, made it nicer.
- Optimized memory usage (vut it by a factor of 2)
- Added freehand (handwriting) input method.
- Added hiragana and katakana handwriting data (hwd 2.0)
  generated by Yuko Inui <yuko@yudit.org>
* Thu Oct 25 2001 Gaspar Sinai <gsinai@yudit.org> patch 1,2,3,4,5,7,8
- renamed yudit-2.4-destdir.patch to //yudit.org/download/yudit-2.4.patch5.txt
- added 7,8
- renamed bz2 to gz in Source:
- removed doc from being doc because yudit uses it.
* Wed Aug 29 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.3-4
- Fix build as non-root
- Add patches from yudit.org
- Set prefix correctly
- Use %%configure
- Add docs
- Add desktop file
- Fix up specfile

